package mcmultipart.client.multipart;

import java.util.ArrayList;
import java.util.List;

import mcmultipart.block.BlockCoverable;
import mcmultipart.block.BlockMultipart;
import mcmultipart.multipart.PartState;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.resources.model.IBakedModel;
import net.minecraft.client.resources.model.ModelResourceLocation;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.client.MinecraftForgeClient;
import net.minecraftforge.client.model.ISmartBlockModel;
import net.minecraftforge.common.property.IExtendedBlockState;

@SuppressWarnings("deprecation")
public class ModelMultipartContainer implements ISmartBlockModel {

    public IBakedModel model;

    private Block block;
    private List<PartState> partStates;

    public ModelMultipartContainer(IBakedModel model) {

        this.model = model;
    }

    private ModelMultipartContainer(List<PartState> partStates, Block block, IBakedModel model) {

        this.partStates = partStates;
        this.block = block;
        this.model = model;
    }

    @Override
    public List<BakedQuad> func_177551_a(EnumFacing face) {

        List<BakedQuad> quads = new ArrayList<BakedQuad>();
        if (model != null
                && (!(block instanceof BlockCoverable) || ((BlockCoverable) block).canRenderInLayerDefault(MinecraftForgeClient
                        .getRenderLayer()))) quads.addAll(model.func_177551_a(face));
        for (PartState partState : partStates) {
            if (!partState.renderLayers.contains(MinecraftForgeClient.getRenderLayer())) continue;

            ModelResourceLocation modelLocation = new ModelResourceLocation(partState.modelPath,
                    MultipartStateMapper.instance.func_178131_a(partState.state.func_177228_b()));
            IBakedModel model = Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178126_b()
                    .func_174953_a(modelLocation);
            if (model != null) {
                model = model instanceof ISmartMultipartModel ? ((ISmartMultipartModel) model).handlePartState(partState.state) : model;
                quads.addAll(model.func_177551_a(face));
            }
        }
        return quads;
    }

    @Override
    public List<BakedQuad> func_177550_a() {

        List<BakedQuad> quads = new ArrayList<BakedQuad>();
        if (model != null
                && (!(block instanceof BlockCoverable) || ((BlockCoverable) block).canRenderInLayerDefault(MinecraftForgeClient
                        .getRenderLayer()))) quads.addAll(model.func_177550_a());

        for (PartState partState : partStates) {
            if (!partState.renderLayers.contains(MinecraftForgeClient.getRenderLayer())) continue;

            ModelResourceLocation modelLocation = new ModelResourceLocation(partState.modelPath,
                    MultipartStateMapper.instance.func_178131_a(partState.state.func_177228_b()));
            IBakedModel model = Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178126_b()
                    .func_174953_a(modelLocation);
            if (model != null) {
                model = model instanceof ISmartMultipartModel ? ((ISmartMultipartModel) model).handlePartState(partState.state) : model;
                quads.addAll(model.func_177550_a());
            }
        }
        return quads;
    }

    @Override
    public boolean func_177555_b() {

        return true;
    }

    @Override
    public boolean func_177556_c() {

        return false;
    }

    @Override
    public boolean func_177553_d() {

        return false;
    }

    @Override
    public TextureAtlasSprite func_177554_e() {

        return model != null ? model.func_177554_e() : Minecraft.func_71410_x().func_147117_R()
                .func_110572_b("minecraft:blocks/stone");
    }

    @Override
    public ItemCameraTransforms func_177552_f() {

        return ItemCameraTransforms.field_178357_a;
    }

    @Override
    public IBakedModel handleBlockState(IBlockState state) {

        return new ModelMultipartContainer(((IExtendedBlockState) state).getValue(BlockMultipart.properties[0]), state.func_177230_c(),
                (model instanceof ISmartBlockModel ? ((ISmartBlockModel) model).handleBlockState(state) : model));
    }

}
